Subject: Re: [Ledger] Researching to leverage Hashed-Timelock Agreements (HTLAs) paradigm for establishing atomicity between different DLT networks for asset swaps with full decentralization

From: Evan Schwartz <[email-masked]>
Date: Mon, 12 Nov 2018 14:18:36 -0500

Hi Nathan,

This isn't a case we've specifically been designing around but streaming payments may help address it. If each of those payments is being streamed in some smaller increment, it would help avoid the gridlock issue. If one of the accounts runs out while the stream is in process, the sender could just keep retrying and the money would keep flowing as soon as the incoming balance had been credited to the account.
Settlement times and mechanisms are determined on a bilateral basis, so pairs of connectors could choose to forward any amount they want on credit.
Hope that helps,
Evan

On Nov 10 2018, at 10:35 am, Nathan Aw <[email-masked]> wrote:
>
> Hi Evan,
>
> Would like to quickly check with you on the questions below. Thanks!
>
> 1. Do you need that whole transaction to happen atomically or for the balances to just end up that way?
> Nathan Aw: Probably the latter? Might be possible to have the different transactions to happen atomically?
>
> 2. Also, do you need every party to maintain their own view of the state of the balances, or is there a single central party that could track them?
> Nathan Aw: Ideally no central party. the decentralized network should be and ideally be intelligent enough to identify these gridlocks and address them automatically, perhaps with the help of some configuration?
>
>
> Are there any of such capabilities in the roadmap?
>
> Regards,
>
> Nathan Aw
> On Thu, Nov 8, 2018 at 11:31 PM Nathan Aw <[email-masked] (mailto:[email-masked])> wrote:
> > Hi Evan,
> >
> > Have provided my response below. Thanks!
> >
> > 1. Do you need that whole transaction to happen atomically or for the balances to just end up that way?
> > Nathan Aw: Probably the latter? Might be possible to have the different transactions to happen atomically?
> >
> > 2. Also, do you need every party to maintain their own view of the state of the balances, or is there a single central party that could track them?
> > Nathan Aw: Ideally no central party. the decentralized network should be and ideally be intelligent enough to identify these gridlocks and address them automatically, perhaps with the help of some configuration?
> >
> >
> > Are there any of such capabilities in the roadmap?
> >
> > Thank you.
> >
> > Regards,
> >
> > Nathan Aw
> > https://sg.linkedin.com/in/awnathan
> >
> > https://datatracker.ietf.org/meeting/103/materials/slides-103-dinrg-decentralized-identity-01
> > https://www.hyperledger.org/news/speakersbureau
> > https://erc725alliance.org/
> > https://www.hyperledger.org/community/technical-ambassador
> > https://www.meetup.com/BlockChain-Dapps-Technology/events/254556114/
> > https://www.hyperledger.org/blog/2017/12/05/developer-showcase-series-nathan-aw-ntt-data
> > https://www.meetup.com/Hyperledger-HK/events/248011521/
> > https://blockchain.ieee.org/newsletter/editorial-board
> >
> >
> >
> > On Thu, Nov 8, 2018 at 2:58 AM Evan Schwartz <[email-masked] (mailto:[email-masked])> wrote:
> > > Hi Nathan,
> > >
> > > Do you need that whole transaction to happen atomically or for the balances to just end up that way? Also, do you need every party to maintain their own view of the state of the balances, or is there a single central party that could track them?
> > > On Nov 7 2018, at 9:03 am, Nathan Aw <[email-masked] (mailto:[email-masked])> wrote:
> > > >
> > > > Hi Evan,
> > > >
> > > > I came up with a gridlock diagram/scenario to illustrate what I wish to hope to solve (or perhaps build) with interledger. Please refer to the gridlock diagram below. Since interledger is the routing layer/network, the gridlock mechanism is something that will be extremely relevant. This mechanism will be a game-changer -- any thoughts/inputs, please?
> > > >
> > > >
> > > >
> > > > Regards,
> > > >
> > > > Nathan Aw
> > > > https://www.linkedin.com/in/awnathan/
> > > > https://datatracker.ietf.org/meeting/103/materials/slides-103-dinrg-decentralized-identity-00
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > > > On Sun, Oct 14, 2018 at 12:22 AM Evan Schwartz <[email-masked] (mailto:[email-masked])> wrote:
> > > > > The same construction can be used no matter what the underlying assets are. They can be cryptocurrencies, fiat currencies, shares of stock or other divisible assets.
> > > > >
> > > > > If you want to use this method for a swap you can send a "payment" from one of your accounts to another.
> > > > > On Sat, Oct 13, 2018, 8:27 AM Nathan Aw <[email-masked] (mailto:[email-masked])> wrote:
> > > > > > Hi all,
> > > > > >
> > > > > > Second try. Thank you.
> > > > > >
> > > > > > I am a blockchain engineer based out of Singapore working at a leading bank in ASEAN.
> > > > > >
> > > > > > I am looking to leverage the Hashed-Timelock Agreements (HTLAs) paradigm for establishing atomicity between different DLT networks for asset swaps to achieve cross border payments with partial to full decentralization in mind.
> > > > > >
> > > > > > With the goal in mind, I like to understand technically how can this paradigm be applied to achieve payment vs payment (pvp) with semi-trusted nodes such as clearinghouses, banks and individual players? Applying the same concept of a crypto swap between ETH and BTC, the same can be applied between SGD and HKD?
> > > > > >
> > > > > > Also, I hope to understand the models around how liquidity can be maintained between these nodes?
> > > > > >
> > > > > > Regards,
> > > > > >
> > > > > > Nathan Aw
> > > > > > https://sg.linkedin.com/in/awnathan
> > > > > >
> > > > > >
> > > > > > https://erc725alliance.org/
> > > > > >
> > > > > >
> > > > > >
> > > > > > On Sat, Oct 13, 2018 at 12:39 AM Nathan Aw <[email-masked] (mailto:[email-masked])> wrote:
> > > > > > > Hi all,
> > > > > > >
> > > > > > > I am a blockchain engineer based out of Singapore working at a leading bank in ASEAN.
> > > > > > >
> > > > > > > I am looking to leverage the Hashed-Timelock Agreements (HTLAs) paradigm for establishing atomicity between different DLT networks for asset swaps to achieve cross border payments with partial to full decentralization in mind.
> > > > > > >
> > > > > > > With the goal in mind, I like to understand technically how can this paradigm be applied to achieve payment vs payment (pvp) with semi-trusted nodes such as clearinghouses, banks and individual players? Applying the same concept of a crypto swap between ETH and BTC, the same can be applied between SGD and HKD?
> > > > > > >
> > > > > > > Also, I hope to understand the models around how liquidity can be maintained between these nodes?
> > > > > > >
> > > > > > > Thank you!
> > > > > > >
> > > > > > > Regards,
> > > > > > >
> > > > > > > Nathan Aw
> > > > > > > https://sg.linkedin.com/in/awnathan
> > > > > > >
> > > > > > > https://erc725alliance.org/
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > > >
> > > > > >
> > > > > >
> > > > > >
> > > > > >
> > > > >
> > > > >
> > > > >
> > > > >
> > > >
> > > >
> > > >
> > >
> >
> >
> >
>
>
>
>